// Suport for Windows ToolHelp.dll

#include <WinTen.h>
#include <Windows.h>
#include <ClipApi.h>
#include <ToolHelp.h>

extern HANDLE __hInstance;

static void far PASCAL _export IntCallBack( void );

static far FARPROC lpfnCallBack = 0;
static far PCLIPVAR bInterruptAction = 0;

//----------------------------------------------------------------------------//

CLIPPER INTERRUPTR() // EGISTER( bAction ) --> lSuccess
{
   if( lpfnCallBack )
   {
      FreeProcInstance( lpfnCallBack );
      lpfnCallBack = 0;
   }

   if( bInterruptAction )
   {
      _DropGrip( bInterruptAction );
      bInterruptAction = 0;
   }

   lpfnCallBack = MakeProcInstance( ( FARPROC ) IntCallBack, __hInstance );

   bInterruptAction = _GetGrip( _param( 1, -1 ) );

   _retl( InterruptRegister( 0, lpfnCallBack ) );
}

//----------------------------------------------------------------------------//

CLIPPER INTERRUPTU() // NREGISTER() --> lSuccess
{
   BOOL bResult = InterruptUnRegister( __hInstance );

   if( bResult )
   {
      if( lpfnCallBack )
      {
         FreeProcInstance( lpfnCallBack );
         lpfnCallBack = 0;
      }

      if( bInterruptAction )
      {
         _DropGrip( bInterruptAction );
         bInterruptAction = 0;
      }
   }
   _retl( bResult );
}

//----------------------------------------------------------------------------//

CLIPPER TIMERCOUNT() // --> { nMsSinceStart, nMsThisVM }
{
   TIMERINFO ti;

   ti.dwSize = sizeof( TIMERINFO );

   if( TimerCount( &ti ) )
   {
      _reta( 2 );
      _stornl( ti.dwmsSinceStart, -1, 1 );
      _stornl( ti.dwmsThisVM, -1, 2 );
   }
   else
      _ret();
}

//----------------------------------------------------------------------------//

static void far PASCAL _export IntCallBack( void )
{
   if( bInterruptAction )
      _cEval0( bInterruptAction );
}

//----------------------------------------------------------------------------//

CLIPPER __GENGPF()
{
   LPWORD pVoid = 0;

   * pVoid = 1;       // We generate here a GPF !!!
}

//----------------------------------------------------------------------------//

CLIPPER TERMINATEA() // PP( hTask, nMode ) --> nil
{
   TerminateApp( _parni( 1 ), IF( PCOUNT() > 1, _parni( 2 ), NO_UAE_BOX ) );
}

//----------------------------------------------------------------------------//
